


#include <tqcstring.h>
#include <tqimage.h>
#include <tqpainter.h>
#include <tqpalette.h>
#include <tqpixmap.h>
#include <tqfont.h>

#include <kjs/object.h>

#include <kjsembed/global.h>
#include <kjsembed/jsobjectproxy.h>
#include <kjsembed/jsopaqueproxy.h>
#include <kjsembed/jsbinding.h>

#include <tqcanvas.h>
#include "qcanvaspolygonalitem_imp.h"

/**
 * Namespace containing the KJSEmbed library.
 */
namespace KJSEmbed {

TQCanvasPolygonalItemImp::TQCanvasPolygonalItemImp( KJS::ExecState *exec, int mid, bool constructor )
   : JSProxyImp(exec), id(mid), cons(constructor)
{
}

TQCanvasPolygonalItemImp::~TQCanvasPolygonalItemImp()
{
}

/**
 * Adds bindings for static methods and enum constants to the specified Object.
 */
void TQCanvasPolygonalItemImp::addStaticBindings( KJS::ExecState *exec, KJS::Object &object )
{
    JSProxy::MethodTable methods[] = {

	{ 0, 0 }
    };

    int idx = 0;
    TQCString lastName;

    while( methods[idx].name ) {
        if ( lastName != methods[idx].name ) {
            TQCanvasPolygonalItemImp *meth = new TQCanvasPolygonalItemImp( exec, methods[idx].id );
            object.put( exec , methods[idx].name, KJS::Object(meth) );
            lastName = methods[idx].name;
        }
        ++idx;
    }


}

/**
 * Adds bindings for instance methods to the specified Object.
 */
void TQCanvasPolygonalItemImp::addBindings( KJS::ExecState *exec, KJS::Object &object )
{
    JSProxy::MethodTable methods[] = {

        { Method_collidesWith_3, "collidesWith" },
        { Method_setPen_4, "setPen" },
        { Method_setBrush_5, "setBrush" },
        { Method_pen_6, "pen" },
        { Method_brush_7, "brush" },
        { Method_areaPoints_8, "areaPoints" },
        { Method_areaPointsAdvanced_9, "areaPointsAdvanced" },
        { Method_boundingRect_10, "boundingRect" },
        { Method_rtti_11, "rtti" },
	{ 0, 0 }
    };

    int idx = 0;
    TQCString lastName;

    while( methods[idx].name ) {
        if ( lastName != methods[idx].name ) {
            TQCanvasPolygonalItemImp *meth = new TQCanvasPolygonalItemImp( exec, methods[idx].id );
            object.put( exec , methods[idx].name, KJS::Object(meth) );
            lastName = methods[idx].name;
        }
        ++idx;
    }
}

/**
 * Extract a TQCanvasPolygonalItem pointer from an Object.
 */
TQCanvasPolygonalItem *TQCanvasPolygonalItemImp::toTQCanvasPolygonalItem( KJS::Object &self )
{
    JSObjectProxy *ob = JSProxy::toObjectProxy( self.imp() );
    if ( ob ) {
        TQObject *obj = ob->object();
	if ( obj )
           return dynamic_cast<TQCanvasPolygonalItem *>( obj );
    }

    JSOpaqueProxy *op = JSProxy::toOpaqueProxy( self.imp() );
    if ( !op )
        return 0;

    if ( op->typeName() != "TQCanvasPolygonalItem" )
        return 0;

    return op->toNative<TQCanvasPolygonalItem>();
}

/**
 * Select and invoke the correct constructor.
 */
KJS::Object TQCanvasPolygonalItemImp::construct( KJS::ExecState *exec, const KJS::List &args )
{
   switch( id ) {

         case Constructor_QCanvasPolygonalItem_1:
             return TQCanvasPolygonalItem_1( exec, args );
             break;

         default:
             break;
    }

    TQString msg = i18n("TQCanvasPolygonalItemCons has no constructor with id '%1'.").arg(id);
    return throwError(exec, msg,KJS::ReferenceError);
}


KJS::Object TQCanvasPolygonalItemImp::TQCanvasPolygonalItem_1( KJS::ExecState *exec, const KJS::List &args )
{

#if 0 // This constructor has been disabled by the XSL template

    // Unsupported parameter TQCanvas *
    return KJS::Object();

    TQCanvas * arg0; // Dummy


    // We should now create an instance of the TQCanvasPolygonalItem object

    TQCanvasPolygonalItem *ret = new TQCanvasPolygonalItem(

          arg0 );


#endif // This constructor has been disabled by the XSL template
	return KJS::Object();
}

KJS::Value TQCanvasPolygonalItemImp::call( KJS::ExecState *exec, KJS::Object &self, const KJS::List &args )
{
    instance = TQCanvasPolygonalItemImp::toTQCanvasPolygonalItem( self );

    switch( id ) {

    case Method_collidesWith_3:
        return collidesWith_3( exec, self, args );
        break;

    case Method_setPen_4:
        return setPen_4( exec, self, args );
        break;

    case Method_setBrush_5:
        return setBrush_5( exec, self, args );
        break;

    case Method_pen_6:
        return pen_6( exec, self, args );
        break;

    case Method_brush_7:
        return brush_7( exec, self, args );
        break;

    case Method_areaPoints_8:
        return areaPoints_8( exec, self, args );
        break;

    case Method_areaPointsAdvanced_9:
        return areaPointsAdvanced_9( exec, self, args );
        break;

    case Method_boundingRect_10:
        return boundingRect_10( exec, self, args );
        break;

    case Method_rtti_11:
        return rtti_11( exec, self, args );
        break;

    default:
        break;
    }

    TQString msg = i18n( "TQCanvasPolygonalItemImp has no method with id '%1'." ).arg( id );
    return throwError(exec, msg,KJS::ReferenceError);
}


KJS::Value TQCanvasPolygonalItemImp::collidesWith_3( KJS::ExecState *exec, KJS::Object &obj, const KJS::List &args )
{

    // Unsupported parameter const TQCanvasItem *
    return KJS::Value();

    const TQCanvasItem * arg0; // Dummy

      bool ret;
      ret = instance->collidesWith(
       arg0 );
      return KJS::Boolean( ret );

}

KJS::Value TQCanvasPolygonalItemImp::setPen_4( KJS::ExecState *exec, KJS::Object &obj, const KJS::List &args )
{

    // Unsupported parameter TQPen
    return KJS::Value();

    TQPen arg0; // Dummy

      instance->setPen(
       arg0 );
      return KJS::Value(); // Returns void

}

KJS::Value TQCanvasPolygonalItemImp::setBrush_5( KJS::ExecState *exec, KJS::Object &obj, const KJS::List &args )
{

    // Unsupported parameter TQBrush
    return KJS::Value();

    TQBrush arg0; // Dummy

      instance->setBrush(
       arg0 );
      return KJS::Value(); // Returns void

}

KJS::Value TQCanvasPolygonalItemImp::pen_6( KJS::ExecState *exec, KJS::Object &obj, const KJS::List &args )
{
    TQPen ret;
      ret = instance->pen(  );

       return convertToValue( exec, ret );

}

KJS::Value TQCanvasPolygonalItemImp::brush_7( KJS::ExecState *exec, KJS::Object &obj, const KJS::List &args )
{
    TQBrush ret;
      ret = instance->brush(  );

       return convertToValue( exec, ret );

}

KJS::Value TQCanvasPolygonalItemImp::areaPoints_8( KJS::ExecState *exec, KJS::Object &obj, const KJS::List &args )
{

      instance->areaPoints(  );
      return KJS::Value(); // Returns 'TQPointArray'

}

KJS::Value TQCanvasPolygonalItemImp::areaPointsAdvanced_9( KJS::ExecState *exec, KJS::Object &obj, const KJS::List &args )
{

      instance->areaPointsAdvanced(  );
      return KJS::Value(); // Returns 'TQPointArray'

}

KJS::Value TQCanvasPolygonalItemImp::boundingRect_10( KJS::ExecState *exec, KJS::Object &obj, const KJS::List &args )
{
    TQRect ret;
      ret = instance->boundingRect(  );

       return convertToValue( exec, ret );

}

KJS::Value TQCanvasPolygonalItemImp::rtti_11( KJS::ExecState *exec, KJS::Object &obj, const KJS::List &args )
{

      int ret;
      ret = instance->rtti(  );
      return KJS::Number( ret );

}


} // namespace KJSEmbed

// Local Variables:
// c-basic-offset: 4
// End:


